﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.WebEdition;
using ThinkGeo.MapSuite.Core;
using System.Collections.ObjectModel;
using System.Data;

namespace SampleWebApp
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        string SQLstr = string.Empty; static System.Data.DataTable dtSQL = new DataTable();
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                GetMapDetails();
                //ShapeFileFeatureLayer talukaLayer = new ShapeFileFeatureLayer(Server.MapPath(@"~\App_Data\ALL.shp"));
            }
        }
        private void GetMapDetails()
        {
            Map1.Visible = true;
            Map1.MapUnit = GeographyUnit.Meter;
            //Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
            //Map1.MapTools.OverlaySwitcher.Enabled = true;
            Map1.MapTools.MouseCoordinate.Enabled = true;
            if (Map1.CustomOverlays.Count > 0)
                Map1.CustomOverlays.Clear();
            //Load GoogleMap Layer
            //GoogleOverlay google = new GoogleOverlay("Google Map");
            //google.JavaScriptLibraryUri = new Uri(System.Configuration.ConfigurationManager.AppSettings["GoogleUri"]);
            //google.GoogleMapType = GoogleMapType.Normal;
            //Map1.CustomOverlays.Add(google);

            //Village Boundary Layer            
            ShapeFileFeatureLayer villageLayer = new ShapeFileFeatureLayer(Server.MapPath(@"~\App_Data\PURANDAR.shp"));
            villageLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.StandardColors.Transparent, GeoColor.StandardColors.OrangeRed, 2);
            villageLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("Village_Na", "Arial", 8, DrawingFontStyles.Bold, GeoColor.StandardColors.Magenta, 0, 0);
            villageLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            //if (villageLayer.RequireIndex == false)
            //    ShapeFileFeatureSource.BuildIndexFile(villageLayer.ShapePathFileName);


            //All Villages with gut numbers
            ShapeFileFeatureLayer talukaLayer = new ShapeFileFeatureLayer(Server.MapPath(@"~\App_Data\ALL.shp"));
            //talukaLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.StandardColors.Transparent, GeoColor.StandardColors.Gray,1);
            AreaStyle areaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.StandardColors.DarkGray);
            talukaLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(areaStyle);
            //talukaLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("Gut_Number", "Arial",7, DrawingFontStyles.Bold, GeoColor.StandardColors.Black, 0, 0);
            ThinkGeo.MapSuite.Core.TextStyle txtStyle = TextStyles.CreateSimpleTextStyle("Gut_Number", "Arial", 8, DrawingFontStyles.Regular, GeoColor.StandardColors.Black, 0, 0);
            talukaLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(txtStyle);
            talukaLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            //if (talukaLayer.RequireIndex == false)
            //    ShapeFileFeatureSource.BuildIndexFile(talukaLayer.ShapePathFileName);

            villageLayer.Open();
            talukaLayer.Open();
            //var fs1 =villageLayer.FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns);
            //var fs2 =talukaLayer.FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns);

            //Apply projection here for WGS_1984_UTM_Zone_43N
            Proj4Projection proj4 = new Proj4Projection();
            proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(32643);
            proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
            proj4.Open();
            talukaLayer.FeatureSource.Projection = proj4;
            villageLayer.FeatureSource.Projection = proj4;

            //ValueStyle valueStyle = new ValueStyle();
            //valueStyle.ColumnName = "Gut_Number";            
            //valueStyle.ValueItems.Add(new ValueItem(".*" + " River", new AreaStyle(new GeoSolidBrush(GeoColor.FromArgb(110, 127, 223, 255)))));
            //valueStyle.ValueItems.Add(new ValueItem("Nala", new AreaStyle(new GeoSolidBrush(GeoColor.StandardColors.LightSteelBlue))));
            //talukaLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(valueStyle);

            LayerOverlay staticOverlay = new LayerOverlay("StaticOverLay");
            staticOverlay.IsBaseOverlay = false;
            staticOverlay.ClientCache.Duration = new TimeSpan(1);

            staticOverlay.Layers.Add("ShapeLayer", talukaLayer);
            staticOverlay.Layers.Add("VillageLayer", villageLayer);

            Map1.CustomOverlays.Add(staticOverlay);
            //talukaLayer.Open();
                        
            //talukaLayer.Close();

            InMemoryFeatureLayer highlightLayer = new InMemoryFeatureLayer();
            ////highlightLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.StandardColors.Black, GeoColor.GeographicColors.Grass);
            ////highlightLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("Gut_Number", "Arial", 7, DrawingFontStyles.Bold, GeoColor.StandardColors.Black, 0, 0);
            AreaStyle inMemareaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.LightYellow, GeoColor.StandardColors.LightGray);
            highlightLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(inMemareaStyle);
            ThinkGeo.MapSuite.Core.TextStyle inMemtxtStyle = TextStyles.CreateSimpleTextStyle("Gut_Number", "Arial", 7, DrawingFontStyles.Regular, GeoColor.StandardColors.Black, 0, 0);
            highlightLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(inMemtxtStyle);
            highlightLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay dynamicOverlay = new LayerOverlay("DynamicOverlay");
            dynamicOverlay.IsBaseOverlay = false;
            //dynamicOverlay.TileType = TileType.SingleTile;
            dynamicOverlay.Layers.Add("HighlightLayer", highlightLayer);
            Map1.CustomOverlays.Add(dynamicOverlay);
            ApplyValueStyle();

            Map1.CurrentExtent = villageLayer.GetBoundingBox();
        }
        private void ApplyValueStyle()
        {
            try
            {


                ShapeFileFeatureLayer dataSourceLayer = (ShapeFileFeatureLayer)((LayerOverlay)Map1.CustomOverlays["StaticOverLay"]).Layers["ShapeLayer"];
                dataSourceLayer.Open();
                //shapeFileLayer.DrawingFeatures += new EventHandler<DrawingFeaturesEventArgs>(shapeFileLayer_DrawingFeatures);

                //SQLstr = "Select Gut_Number from ALL where Village_Na='Gurholi'";

                InMemoryFeatureLayer tempSourceLayer = new InMemoryFeatureLayer();
                tempSourceLayer.Open();

                tempSourceLayer.Columns.Clear();
                foreach (FeatureSourceColumn c in dataSourceLayer.FeatureSource.GetColumns())
                {
                    tempSourceLayer.Columns.Add(c);
                }

                tempSourceLayer.InternalFeatures.Clear();                
                foreach (Feature f in dataSourceLayer.FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns))
                {
                    if (f.ColumnValues["Village_Na"] == "Gurholi")
                    {
                        tempSourceLayer.InternalFeatures.Add(f);
                    }
                }

                AreaStyle areaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.StandardColors.DarkGray);
                tempSourceLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(areaStyle);
                TextStyle txtStyle = TextStyles.CreateSimpleTextStyle("Gut_Number", "Arial", 8, DrawingFontStyles.Regular, GeoColor.StandardColors.Black, 0, 0);
                tempSourceLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(txtStyle);
                tempSourceLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                InMemoryFeatureLayer highlightLayer = (InMemoryFeatureLayer)((LayerOverlay)Map1.CustomOverlays["DynamicOverlay"]).Layers["HighlightLayer"];
                highlightLayer.Open();
                highlightLayer.Columns.Add(new FeatureSourceColumn("GovtLand_G"));

                //dataRenderLayer.Open();
                //SQLstr = "Select Gut_Number from ALL where Village_Na='Gurholi'";
                //dtSQL = shapeFileLayer.QueryTools.ExecuteQuery(SQLstr);
                //dataRenderLayer.FeatureSource.Open();
                Collection<Feature> features1 = tempSourceLayer.QueryTools.GetAllFeatures(ReturningColumnsType.AllColumns);
                highlightLayer.InternalFeatures.Clear();
                for (int i = 0; i < features1.Count; i++)
                {
                    if (features1[i].ColumnValues["Village_Na"] == "Gurholi" && (features1[i].ColumnValues["GovtLand_G"] == "Forest" || features1[i].ColumnValues["GovtLand_G"] == "Government"))
                    {
                        highlightLayer.InternalFeatures.Add(features1[i].Id, features1[i]);
                    }
                }
                tempSourceLayer.Close();

                ValueStyle valueStyle = new ValueStyle();
                valueStyle.ColumnName = "GovtLand_G";
                valueStyle.ValueItems.Add(new ValueItem("Forest", new AreaStyle(new GeoSolidBrush(GeoColor.FromArgb(130, 38, 153, 0)))));
                valueStyle.ValueItems.Add(new ValueItem("Government", new AreaStyle(new GeoSolidBrush(GeoColor.FromArgb(110, 245, 245, 122)))));
                highlightLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(valueStyle);
                highlightLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                if (highlightLayer.InternalFeatures.Count > 0)
                {
                    //highlightLayer.Open();
                    //Map1.CurrentExtent = highlightLayer.GetBoundingBox();
                    //highlightLayer.Close();
                }
                else
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "alert", " alert('No Data Found...');", true);
            }
            catch (Exception ex)
            {
                throw ex;
                //ex = Errorlog.LoggingError(ex, "LandAssetMapping", "drpVillage_SelectedIndexChanged()");
                //Response.Redirect("~/Pages/Error.aspx?ExceptionId=" + ex.Data["ExceptionId"].ToString());
            }
        }
        //void shapeFileLayer_DrawingFeatures(object sender, DrawingFeaturesEventArgs e)
        //{
        //    Collection<Feature> featuresToDrawn = new Collection<Feature>();
        //    ShapeFileFeatureLayer shapeFileLayer = (ShapeFileFeatureLayer)((LayerOverlay)Map1.CustomOverlays["StaticOverLay"]).Layers["ShapeLayer"];

        //    //shapeFileLayer.Open();
        //    //Collection<Feature> AllFeatures = shapeFileLayer.QueryTools.GetAllFeatures(ReturningColumnsType.AllColumns);

        //    for (int i = 0; i < dtSQL.Rows.Count; i++)
        //    {
        //        //shapeFileLayer.FeatureSource.Open();
        //        shapeFileLayer.Open();
        //        //int vGut = GetNumberOnly(dtSQL.Rows[i]["Gut_Number"].ToString());
        //        //Feature vfeature = shapeFileLayer.QueryTools.GetFeatureById(vGut.ToString(), ReturningColumnsType.AllColumns); 

        //        //foreach (Feature feature in e.FeaturesToDraw)
        //        //{
        //        Collection<Feature> vfeature = shapeFileLayer.QueryTools.GetFeaturesByColumnValue("Gut_Number", dtSQL.Rows[i]["Gut_Number"].ToString());
        //        //if (feature.Id == vfeature[0].Id)
        //        //{
        //        if (vfeature != null)
        //        {
        //            featuresToDrawn.Add(vfeature[0]);
        //        }
        //        //}
        //        //}
        //    }

        //    e.FeaturesToDraw.Clear();
        //    foreach (Feature feature in featuresToDrawn)
        //    {
        //        e.FeaturesToDraw.Add(feature);
        //    }
        //}
        //private int GetNumberOnly(string GutNo)
        //{
        //    int i = 0;
        //    string[] numbers = System.Text.RegularExpressions.Regex.Split(GutNo, @"\D+");
        //    foreach (string value in numbers)
        //    {
        //        if (!string.IsNullOrEmpty(value))
        //            i = int.Parse(value);
        //    }
        //    return i;
        //}
    }
}